<?php
class UptimeAgentConfController extends AppController
{   
	var $helpers = array('Html','Xml');
	var $uses=array('Group','Configure', 'Validation','License',
		"Grpshd", "Rltshdmod",'Host','Rlthstgrp','Poll',
		'Hstactivelog');
	var $components = array();
	var $layout='system';
		
	function beforeFilter()
	{

	}
	function addhost($name, $groupid = 1){
		$criteria = array();
		$criteria[] = "(Host.host_name = '".$this->Lv->spec_char_dbm($name)."' or Host.access_name = '".$this->Lv->spec_char_dbm($name)."')";
		$host = $this->Host->find($criteria);
		if(!empty($host)){
			echo $host['Host']['id'];
			exit;
		}else{
			//登録の無いPCを記録
			set_time_limit(0);
			$tmp =str_replace("\\","/", RESTORE_FILE_PATH);
			$logdir = $tmp . "/../Nonreg";
			if(!file_exists($logdir)){
				mkdir($logdir);
			}
			$file = $logdir. "/hosts.txt";
			$form_data = sprintf("%s,%s\r\n", date("Y/m/d H:i:s"), $name);
			$txt = fopen($file,'a'); 
			if(!$txt)
			{
				echo "0";
				exit;
			}
			flock($txt, LOCK_EX);
			fwrite($txt,$form_data); 
			fclose($txt); 
			
			echo "0";
			exit;
		}
		/*$regist = date('Y-m-d H:i:s',time());
		$allupdatedate = Array('Host' => Array(
								'host_name' => $this->Lv->spec_char_dbm($name),
								'access_name' => $this->Lv->spec_char_dbm($name),
								'poll_id' => 0,
								'poll_type' => 0,
								'status' => 2,
								'isagent' => 1,
								'regist_time' => $regist,
								'update_time' => $regist)
								);
		
		$this->Host->save($allupdatedate);
		$criteria[] = "Host.regist_time = '".$regist."'";
		$data= $this->Host->find($criteria);
		$addgroupdate=Array(
				'Rlthstgrp' => Array(
				'host_id' => $data['Host']['id'],
				'group_id' => $groupid,
				)
				);
		$this->Rlthstgrp->save($addgroupdate);
		echo $data['Host']['id'];*/
		
	}
	
	function getParentschedule($groupid)
	{
		$default = $this->Grpshd->find(array("group_id" => $groupid),
			array('Grpshd.id','Grpshd.group_id',
				'Grpshd.start_date','Grpshd.end_date','Grpshd.start_time','Grpshd.end_time',
				'Grpshd.weekday','Grpshd.onlogon',
				'timediff(end_time,start_time) as Grpshd__time_diff',
				'time_to_sec(timediff(end_time,start_time)) as Grpshd__second_diff'));
		if(empty($default))
		{
			$parent = $this->Group->group_father_id($groupid);
			if(!empty($parent))
				$default = $this->getParentschedule($parent);
		}
		return $default;
	}
	
	function getschedule($group_id)
	{
		require_once( '../csv/xml.php' );
		$xml = new xml(); 
		$xml->setSpace(true); 
		
		$d = &$xml->addDeclare('?xml'); 
        $d->setAttrib("version","1.0");
        $d->setAttrib("encoding","Shift_JIS");
		
		$version = 100;

		$conf = $this->getParentschedule($group_id);
		$xml1 = &$xml->addElement("Schedule"); 

		if(!empty($conf)){
			//ライセンスの確認
			$license_endtime=$this->License->findAll(array("1=1"),array("License.end_time"));
			//取得期間が無期限の場合、現在からライセンスの期限までとする 
			if(($conf['Grpshd']['start_date']==$conf['Grpshd']['end_date'])&&($conf['Grpshd']['end_date']=="2038-01-01"))
			{
				$conf['Grpshd']['start_date'] = date("Y-m-d");
				$conf['Grpshd']['end_date'] = substr($license_endtime[0]['License']['end_time'],0,10);
			}
			
			$xml2 = $xml1->addElement("Item", ""); 

			$names = array('id', 'group_id',
				'start_date','end_date','start_time','end_time',
				'weekday','onlogon','time_diff','second_diff');
			foreach($conf['Grpshd'] as $key=>$value)
			{
				if(in_array($key, $names))
					$xml2->setAttrib($key, $value); 
			}
			$sch_id = $conf['Grpshd']['id'];
			$agent = $this->Rltshdmod->find(array("Rltshdmod.sch_id" => $sch_id, "Rltshdmod.module_id" => 20));

			if(isset($agent['Rltshdmod']['inter_time']))
				$xml2->setAttrib("agenttime", $agent['Rltshdmod']['inter_time']); 
			else
				$xml2->setAttrib("agenttime", SCHEDULE_AGENT); 
		}
		$rec = $xml->toString();
		
		echo $rec;exit;
	}
	
	//グループの基本設定を取得　無い場合は親の設定を取得
	function getTimecontrol($groupid)
	{
		$default = $this->Timecontrol->find(array("group_id" => $groupid));
		if(empty($default))
		{
			$parent = $this->Group->group_father_id($groupid);
			if(!empty($parent))
				$default = $this->getTimecontrol($parent);
		}
		return $default;
	}
	
	//timekeeperエージェントから受信
	function upload(){
		$tslog = $_POST['tslog'];
		$interval = $_POST['interval'];
		$hostid = $_POST['hostid'];
		$account = isset($_POST['account']) ? $this->Lv->spec_char_dbm($_POST['account']) : null;
		$key = isset($_POST['key']) ? $this->Lv->spec_char_dbm($_POST['key']) : null;
		
		if(empty($tslog)){
			$tslog = $_GET['tslog'];
			$interval = $_GET['interval'];
			$hostid = $_GET['hostid'];
			$account = isset($_GET['account']) ? $this->Lv->spec_char_dbm($_GET['account']) : null;
			$key = isset($_GET['key']) ? $this->Lv->spec_char_dbm($_GET['key']) : null;
		}
		$tslog = date('Y-m-d H:i:s', strtotime($tslog));
		
		$cond = array(
				"Hstactivelog.host_id" => $hostid, 
				"Hstactivelog.account" => $account, 
				"Hstactivelog.start < '{$tslog}'");
		$cond["GROUP BY"] = "Hstactivelog.host_id,Hstactivelog.account";
		$last = $this->Hstactivelog->find(
			$cond,
			"max(Hstactivelog.start) as Hstactivelog__maxtime");
//var_dump($last);exit;
		if(isset($last['Hstactivelog']['maxtime'])){
			$maxtime = $last['Hstactivelog']['maxtime'];
			
			//前回のログと同じ日か
			$time = strtotime($maxtime);
			$startDay = date('Y-m-d 00:00', $time);
			$endDay = date('Y-m-d 00:00', strtotime("+1 day", $time));
			$curtday = date('Y-m-d 00:00', strtotime($tslog));
			if($startDay == $curtday)
				$today = true;
			else
				$today = false;
			
			$last = $this->Hstactivelog->find(array(
				"Hstactivelog.host_id" => $hostid, 
				"Hstactivelog.account" => $account, 
				"Hstactivelog.start" => $maxtime));
			$previous = $last['Hstactivelog'];
			if(is_null($previous['stop'])  ){
				if($today){
					$span = $interval*2;
					$stop = strtotime($previous['active']." + ".$span." second");
					if($stop > strtotime($endDay))
						$stop = strtotime($endDay);
					if(strtotime($tslog) > $stop){
						//更新+挿入
						//最後に稼働だった時刻+インターバルを終了時刻に
						
						$this->setstop($hostid, $interval);

						$stop = strtotime($previous['active']." + ".$interval." second");
						if($stop > strtotime($endDay))
							$stop = strtotime($endDay);
						/*$previous['id'] = $previous['id'] + 0;
						$previous['stop'] = date('Y-m-d H:i:s',$stop);
						$previous['final'] = date('Y-m-d H:i:s',$stop);
						$update = array('Hstactivelog' => $previous);

						if($this->Hstactivelog->save($update))
							echo 1;
						else
							echo 0;*/
						
						$newlog = array(
							'Hstactivelog' => array(
									'host_id' => $hostid,
									'log_status' => 1,
									'previous' => date('Y-m-d H:i:s',$stop),
									'start' => $tslog,
									'active' => $tslog,
									'stop' => null,
									'final' => null,
									'account' => $account
									)
							); 	
					
						$time = strtotime($tslog);
						$startToday = sprintf("%s 00:00", date('Y-m-d', $time));
						$am = 0;
						$pm = 0;
						$this->calc($startToday, $tslog, $am, $pm);
						$newlog['Hstactivelog']['times_am'] = $am;
						$newlog['Hstactivelog']['times_pm'] = $pm;
						
						$this->Hstactivelog->create();
						$this->Hstactivelog->save($newlog);	
						echo "1";
					}else{
						//更新
						$previous['active'] = $tslog;
						$previous['account'] = $account;
						$am = 0;
						$pm = 0;
						$this->calc($startDay, $tslog, $am, $pm);
						$previous['times_am'] = $previous['times_am'] | $am;
						$previous['times_pm'] = $previous['times_pm'] | $pm;
						$update = array('Hstactivelog' => $previous);
						if($this->Hstactivelog->save($update))
							echo 1;
						else
							echo 0;	
					}
				
				

				}else{//更新+挿入
					//最後に稼働だった時刻+インターバルを終了時刻に
					$this->setstop($hostid, $interval);
					
					$stop = strtotime($previous['active']." + ".$interval." second");
					if($stop > strtotime($endDay))
						$stop = strtotime($endDay);
					/*$previous['id'] = $previous['id'] + 0;
					$previous['stop'] = date('Y-m-d H:i:s',$stop);
					$previous['final'] = date('Y-m-d H:i:s',$stop);
					$update = array('Hstactivelog' => $previous);

					if($this->Hstactivelog->save($update))
						echo 1;
					else
						echo 0;*/
					
					$newlog = array(
						'Hstactivelog' => array(
								'host_id' => $hostid,
								'log_status' => 1,
								'previous' => date('Y-m-d H:i:s',$stop),
								'start' => $tslog,
								'active' => $tslog,
								'stop' => null,
								'final' => null,
								'account' => $account
								)
						); 	
				
					$time = strtotime($tslog);
					$startToday = sprintf("%s 00:00", date('Y-m-d', $time));
					$am = 0;
					$pm = 0;
					$this->calc($startToday, $tslog, $am, $pm);
					$newlog['Hstactivelog']['times_am'] = $am;
					$newlog['Hstactivelog']['times_pm'] = $pm;
					
					$this->Hstactivelog->create();
					$this->Hstactivelog->save($newlog);	
					echo "1";
				}
			}else{
				/*//起こりえない
				if($today){
					$previous['active'] = $tslog;
					$previous['account'] = $account;
					$am = 0;
					$pm = 0;
					$this->calc($startDay, $tslog, $am, $pm);
					$previous['times_am'] = $previous['times_am'] | $am;
					$previous['times_pm'] = $previous['times_pm'] | $pm;
					$previous['stop'] = null;
					$previous['final'] = null;
					$update = array('Hstactivelog' => $previous);
					if($this->Hstactivelog->save($update))
						echo 1;
					else
						echo 0;
				}else*/{
					$this->setstop($hostid, $interval);
					
					$newlog = array(
						'Hstactivelog' => array(
								'host_id' => $hostid,
								'log_status' => 1,
								'previous' => $previous['stop'],
								'start' => $tslog,
								'active' => $tslog,
								'stop' => null,
								'final' => null,
								'account' => $account
								)
						); 	
				
					$time = strtotime($tslog);
					$startToday = sprintf("%s 00:00", date('Y-m-d', $time));
					$am = 0;
					$pm = 0;
					$this->calc($startToday, $tslog, $am, $pm);
					$newlog['Hstactivelog']['times_am'] = $am;
					$newlog['Hstactivelog']['times_pm'] = $pm;
			
					$this->Hstactivelog->save($newlog);	
					echo "1";
				}
			}
		}else{//initial
			$this->setstop($hostid, $interval);
		
			$newlog = array(
				'Hstactivelog' => array(
						'host_id' => $hostid,
						'log_status' => 1,
						'previous' => null,
						'start' => $tslog,
						'active' => $tslog,
						'stop' => null,
						'final' => null,
						'account' => $account
						)
				); 	
				
			$time = strtotime($tslog);
			$startToday = sprintf("%s 00:00", date('Y-m-d', $time));
			$am = 0;
			$pm = 0;
			$this->calc($startToday, $tslog, $am, $pm);
			$newlog['Hstactivelog']['times_am'] = $am;
			$newlog['Hstactivelog']['times_pm'] = $pm;
	
			$this->Hstactivelog->save($newlog);	
			echo "1";
		}
		echo "0";
		exit;
	}
	
	function setstop($hostid, $interval){
		$this->Hstactivelog->query("update hstactivelogs 
set stop = (
	CASE
		WHEN active + interval ".$interval." second > cast(active + interval 1 day as date) then cast(active + interval 1 day as date)
		ELSE active + interval ".$interval." second
	END
),
final = stop
where stop is null
and host_id = ".$hostid);
		
	}
	
	//SPOOLにアップ
	function uplog($psid = 0)
	{
		//$this->layout='ajax';
		set_time_limit(0);

		if(!is_numeric($psid)){
			echo "0";
			exit;
		}
		
		$criteria[] = "Poll.id = ".$psid;
		$poll = $this->Poll->find($criteria);
		if(empty($poll)){
			echo "0";
			exit;
		}
			
		//		debug($_FILES, true);
		//アップロードされたファイルのパス
		$filename = $_FILES['impfile']['tmp_name'];
		if(!empty($filename)){
			//一時フォルダから移動
			//$tmp = str_replace("\\","/", TMP);// lv/app/tmp/
			$tmp =str_replace("\\","/", SPOOL_PATH);
			//$uploadfile = $dir . basename($filename);
			$logdir = $tmp . "/agent";
			if(!file_exists($logdir)){
				mkdir($logdir);
			}
			$logdir = $tmp . "/agent/data";
			if(!file_exists($logdir)){
				mkdir($logdir);
			}
			$name = basename($_FILES['impfile']['name']);
			$uploadfile = $logdir. "/" . $name;
			move_uploaded_file($filename, $uploadfile);
			
			echo "1";
		}
		exit;
	}
	
	//更新のログ
	function updatelog($hostid = 0)
	{
		//$this->layout='ajax';
		set_time_limit(0);

		if($hostid == 0 || !is_numeric($hostid))
			exit;
		
		$criteria[] = "Host.id = ".$hostid;
		$host = $this->Host->find($criteria);
		if(empty($host))
			exit;
			
		//		debug($_FILES, true);
		//アップロードされたファイルのパス
		$filename = $_FILES['impfile']['tmp_name'];
		if(!empty($filename)){
			//一時フォルダから移動
			//$tmp = str_replace("\\","/", TMP);// lv/app/tmp/
			$tmp =str_replace("\\","/", RESTORE_FILE_PATH);
			//$uploadfile = $dir . basename($filename);
			$logdir = $tmp . "/../Agentlogs";
			if(!file_exists($logdir)){
				mkdir($logdir);
			}
			$uploadfile = $logdir. "/" . $hostid ."_".date("YmdHis"). ".txt";
			move_uploaded_file($filename, $uploadfile);
			
			//$my_file = file_get_contents($uploadfile, false, NULL, 0, 60000);
			//unlink($uploadfile);
			
			echo "1";
			//echo $filename."&&&".$uploadfile;
		}
		exit;
	}
	
	function calc($strstart, $strtime, &$am, &$pm){
		$s = strtotime($strstart);
		$n = strtotime($strtime);
		$diff = $n - $s;
		$t = floor($diff/60/30);
		//echo "/t".$t;
		if(0 <= $t && $t < 24){
			$am = 1 << $t;
		}else if(24 <= $t && $t < 48){
			$pm = 1 << ($t - 24);
		}
	}
}
?>